// Supports only integers, the operators '+', '-', '*' and '/' and one prefix ('+' or '-') per integer; no white space.
// Open Serial monitor and type in equation like  -3*5/2-3-1/-6 without '=', then and press enter.
// All valid operators will be deleted automatically after last integer in the equation, e.g. -3*5/2-3-1/-6-- will be
// interpreted as -3*5/2-3-1/-6

String EquationStringBuffer = ""; // stores the user input
String EquationString = ""; // stores the equation
String Number = ""; // stores an integer in the equation
float operandsArray [21]; // stores the operands of the equation
int numberPositionEnd [21]; // stores the end position of numbers in the String
float MultiplicationArray [21]; // stores numbers which need to be multiplicated
float AdditionArray [21]; // stores numbers which need to be added
char* ErrorMessage[] = {"Error. Division by 0", "Error. Too many Integers. Maximum 20", "Error. Integer too long"}; 

void setup() {
  Serial.begin (9600);
}

void loop() {
  while (1) {
    while (Serial.available()) {
    delay(3);  
    if (Serial.available() > 0) {
      char c = Serial.read();  
      EquationStringBuffer += c; 
    } 
  }
  if (EquationStringBuffer.length() > 0) {
    EquationString = EquationStringBuffer;
    Serial.print(EquationString);
    Serial.print(" = ");
    EquationStringBuffer = "";
    break;
  }
 }
  int ErrorCode = 0;
  int numberCounter = 0;
  boolean digitCounter = false;
  for (int i = (EquationString.length()-1); i > -1; i --) { // delete any operators after last number in EquationString
    if (EquationString.charAt(i) == '-' || EquationString.charAt(i) == '+' || EquationString.charAt(i) == '*' || EquationString.charAt(i) == '/') {
      EquationString = EquationString.substring(0, i);
    } else break;
  }
  EquationString += '-'; // add this character on the end of the string to recognize last number of equation
  for (int i = 0; i < EquationString.length(); i ++) { // there must start numbers
    if (EquationString.charAt(i) == '0' || EquationString.charAt(i) == '1' || EquationString.charAt(i) == '2' || EquationString.charAt(i) == '3' || EquationString.charAt(i) == '4'
    || EquationString.charAt(i) == '5' || EquationString.charAt(i) == '6' || EquationString.charAt(i) == '7'|| EquationString.charAt(i) == '8' || EquationString.charAt(i) == '9') {
      if (EquationString.charAt(i - 1) == '-') {
        Number += '-';
        Number += EquationString.charAt(i);
        digitCounter = true;
      } else {
        Number += EquationString.charAt(i);
        digitCounter = true;
      }  
    } else if (EquationString.charAt(i) != '0' && EquationString.charAt(i) != '1' && EquationString.charAt(i) != '2' && EquationString.charAt(i) != '3' && EquationString.charAt(i) != '4'
    && EquationString.charAt(i) != '5' && EquationString.charAt(i) != '6' && EquationString.charAt(i) != '7'&& EquationString.charAt(i) != '8' && EquationString.charAt(i) != '9' && 
    digitCounter == true) {
      char Number_buffer[Number.length() + 1];
      Number.toCharArray(Number_buffer, Number.length() + 1); // copies the string's characters to Number_buffer char array
      float NumberToArray = atof(Number_buffer); // convert  to float
      if (NumberToArray > 999999.0) ErrorCode = 3;
      operandsArray [numberCounter] = NumberToArray; // store in operandsArray 
      numberPositionEnd [numberCounter] = i;
      numberCounter ++;
      digitCounter = false;
      Number = "";
    }
  }
  if (numberCounter > 20) ErrorCode = 2;
  int MultiplicationCounter = 0;
  int AdditionCounter = 0;
  for (int i = 0; i < numberCounter; i ++) { 
    if (EquationString.charAt(numberPositionEnd [i]) == '*' || EquationString.charAt(numberPositionEnd [i]) == '/') {
      if (EquationString.charAt(numberPositionEnd [i]) == '*') {
        MultiplicationArray [MultiplicationCounter] = operandsArray [i];
        MultiplicationCounter ++;
      }
      if (EquationString.charAt(numberPositionEnd [i]) == '/') {
        if (operandsArray [i + 1] == 0.0) ErrorCode = 1;
        operandsArray [i + 1] = 1/operandsArray [i + 1]; // reciprocal next number 
        MultiplicationArray [MultiplicationCounter] = operandsArray [i];
        MultiplicationCounter ++;
      }
    }
    float MultificationsBuffer = 1.0;
    if (EquationString.charAt(numberPositionEnd [i]) != '*' && EquationString.charAt(numberPositionEnd [i]) != '/' && MultiplicationCounter > 0) {
       MultiplicationArray [MultiplicationCounter] = operandsArray [i];
       for (int k = 0; k < MultiplicationCounter + 1; k ++) {
         MultificationsBuffer = MultificationsBuffer * MultiplicationArray [k];
      }
      MultiplicationCounter = 0;
      AdditionArray [AdditionCounter] = (MultificationsBuffer);
      AdditionCounter ++;
    } 
    if (i == 0 && EquationString.charAt(numberPositionEnd [0]) != '*' && EquationString.charAt(numberPositionEnd [0]) != '/') {
      AdditionArray [AdditionCounter] = operandsArray [0];
      AdditionCounter ++;
    }
    if (i == (numberCounter - 1) && numberCounter > 1 && EquationString.charAt(numberPositionEnd [numberCounter - 2]) != '*' 
    && EquationString.charAt(numberPositionEnd [numberCounter - 2]) != '/') {
      AdditionArray [AdditionCounter] = operandsArray [i];
      AdditionCounter ++;
    }
    if (i > 0 && i != numberCounter - 1 && EquationString.charAt(numberPositionEnd [i]) != '*' && EquationString.charAt(numberPositionEnd [i]) != '/' 
    && EquationString.charAt(numberPositionEnd [i - 1]) != '*' && EquationString.charAt(numberPositionEnd [i - 1]) != '/' ) { 
      AdditionArray [AdditionCounter] = operandsArray [i]; 
      AdditionCounter ++;
    }
  }
  float AdditionsBuffer = 0;
  for (int n = 0; n < AdditionCounter; n ++) {
    AdditionsBuffer = AdditionsBuffer + AdditionArray [n];
  }
  switch (ErrorCode) {
    case 0:
    Serial.println(AdditionsBuffer); // print result
    break;
    case 1:
    Serial.println(ErrorMessage[0]);
    break;
    case 2:
    Serial.println(ErrorMessage[1]);
    break;
    case 3:
    Serial.println(ErrorMessage[2]);
    break;
  }
}
